/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2025 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include "ST7735.h"
#include "GFX_FUNCTIONS.h"
#include "stm32f4xx_hal.h"
#include "string.h"
#include <stdbool.h>
#include <stdio.h>
#include <math.h> // Не забудьте подключить библиотеку math.h
extern unsigned short testImage[];
/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */
#define LED_SCREEN1 HAL_GPIO_WritePin(GPIOA, GPIO_PIN_4, GPIO_PIN_SET);
#define LED_SCREEN0 HAL_GPIO_WritePin(GPIOA, GPIO_PIN_4, GPIO_PIN_RESET);
#define RELAY_PIN1 HAL_GPIO_WritePin(GPIOB, GPIO_PIN_14, GPIO_PIN_SET);
#define RELAY_PIN0 HAL_GPIO_WritePin(GPIOB, GPIO_PIN_14, GPIO_PIN_RESET);
#define MAX6675_CS1 HAL_GPIO_WritePin(GPIOB, GPIO_PIN_12, GPIO_PIN_SET);
#define MAX6675_CS0 HAL_GPIO_WritePin(GPIOB, GPIO_PIN_12, GPIO_PIN_RESET);
#define Speak_CS1 HAL_GPIO_WritePin(GPIOB, GPIO_PIN_13, GPIO_PIN_SET);
#define Speak_CS0 HAL_GPIO_WritePin(GPIOB, GPIO_PIN_13, GPIO_PIN_RESET);
float Kp = 3.0;
float Ki = 0.0;
float Kd = 2.9;
volatile uint16_t data3;
volatile uint16_t data2 = 0;
volatile uint16_t data4 = 100;
volatile uint16_t data5;
uint8_t data8[2];

volatile bool encFlag = 1;
float integral = 0;
float last_error = 0;
volatile int counter = 0;
float last_output = 0.0;
float second_last_output = 0.0;
volatile bool oscillating = false;
char buffer[100] = {0};
char buffer1[100] = {0};
char buffer3[10] = {0};
volatile bool err1 = 0;
uint8_t hours = 0;
uint8_t minutes = 30;
uint8_t seconds = 0;
volatile bool speak_flag = 0;
volatile bool speak_flag1 = 0;
volatile bool timer_running = 0;
float current_temperature;
/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */

/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
SPI_HandleTypeDef hspi1;
SPI_HandleTypeDef hspi2;

/* USER CODE BEGIN PV */

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_SPI1_Init(void);
static void MX_SPI2_Init(void);

/* USER CODE BEGIN PFP */

/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
uint16_t ReadTemperature(void){
        	 MAX6675_CS0;
        	      HAL_SPI_Receive(&hspi2, data8, 2, 100);
        	      int16_t temp = ((data8[1] << 8) | data8[0]) >> 3;
        	      MAX6675_CS1;
        	    float temperature = (float)temp * 0.25;
        	    static float temp_filtered = 0;
        	        float alpha = 0.1;
        	        temp_filtered = (1 - alpha) * temp_filtered + alpha * temperature;
        	        return temp_filtered;

    }
char buffer2[8] = {0};
void IndicationERR1(){
	ST7735_SetRotation(1);
	fillRect(5, 93, 100, 19, WHITE);
	ST7735_SetRotation(1);
	ST7735_WriteString(50, 93, "ERR1", Font_11x18, RED, WHITE);
	err1 = 1;
	HAL_Delay(500);

	}
	void IndicationERR2(){

	ST7735_SetRotation(1);
	fillRect(5, 93, 100, 19, WHITE);
	ST7735_SetRotation(1);
	ST7735_WriteString(50, 93, "ERR2", Font_11x18, RED, WHITE);
	err1 = 1;
	HAL_Delay(500);
	//Buzzer_Peak();
	}
	void beep(void) {
		Speak_CS1;
		HAL_Delay(10);
	    Speak_CS0;
	}

	void Speak_Stop(void) {
		Speak_CS1;
		HAL_Delay(700);
		Speak_CS0;
		HAL_Delay(300);
		Speak_CS1;
		HAL_Delay(700);
		Speak_CS0;
		HAL_Delay(300);
		Speak_CS1;
		HAL_Delay(700);
		Speak_CS0;

	}

/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{

  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_SPI1_Init();
  MX_SPI2_Init();
  /* USER CODE BEGIN 2 */
  LED_SCREEN0;
  ST7735_Init(0);
  RELAY_PIN0;
    fillScreen(BLACK);
    HAL_Delay(200);
    LED_SCREEN1;
       ST7735_SetRotation(1);
       ST7735_SetBackgroundImage(0, 0, 160, 128, testImage);
       HAL_Delay(10000);
       ST7735_SetRotation(2);
           fillScreen(WHITE);


           ST7735_SetRotation(1);
                           	 ST7735_FillRectangle(0, 0, 160, 24, RED);
                           	 //HAL_Delay(300);

               ST7735_SetRotation(3);
                           	   ST7735_FillRectangle(0, 0, 160, 15, WHITE);

                           	 //  HAL_Delay(300);

                           	   ST7735_SetRotation(1);
                           	   sprintf(buffer2, "TEK");
                           	   ST7735_WriteString(20, 5, buffer2, Font_11x18, WHITE, RED);
                           	   ST7735_SetRotation(1);
                           	   ST7735_WriteString(110, 5, "YCT", Font_11x18, WHITE, RED);
                           	 //  HAL_Delay(100);

                           	   //ST7735_SetRotation(1);
                           	   //ST7735_WriteString(5, 117, "bitcom63.ru          v1.2", Font_6x8, BLACK, WHITE);

  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */
  while (1)
  {
    /* USER CODE END WHILE */
	  float current_temperature = ReadTemperature();
	  	 	  	  data3 = ReadTemperature();

	  	 	  	  sprintf(buffer, "%d ", data3);
	  	 	  	  	 	  	  	  	  	   	 ST7735_SetRotation(1);
	  	 	  	  	 	  	  	  	  	   	 	  	  	  	    ST7735_WriteString(10, 40, buffer, Font_16x26, RED, WHITE);
	  	 	  	  	 	  	  	  	  	   	 	 HAL_Delay(100);
	  	 	  if (encFlag) {

	  	 	   	       	  data2 = counter;
	  	 	   	 sprintf(buffer1, "%d ", data2);
	  	 	   	 ST7735_SetRotation(1);
	  	 	   	 	  	  	  	    ST7735_WriteString(100, 40, buffer1, Font_16x26, BLACK, WHITE);
	  	 	   	 	  	encFlag = 0;
	  	 	   	 	  	HAL_Delay(10);
	  	 	   	        }
	  	 sprintf(buffer3, "%02d:%02d:%02d ", hours, minutes, seconds);
	  	 ST7735_SetRotation(1);
	  	 ST7735_WriteString(10, 70, buffer3, Font_11x18, RED, WHITE);
	  	 static uint32_t last_time4 = 0;
	  //if (data3 < 2){
	  	 	 	  	  	 	 	  	  	//	IndicationERR2();
	  	 	 	  	  	 	 	  	  //	timer_running = false;
	  	 	 	  	  	 	 	//hours=0;
	  	 	 	  	  	 	 	//	 	minutes=0;
	  	 	 	  	  	 	 		 	//seconds =0;

	  	 	 	  	  	 	 	  	  	  	  	        		  	          //RELAY_PIN0;
	  	 	 	  	  	 	 	  	  	  	  	        //  }else{timer_running=true;
	  	 	 	  	  	 	 	  	  	  	  	        //  err1 = 0;}


	  	 if (timer_running == true && err1 == 0) {


	  	     /* USER CODE END WHILE */

	  	 	 	  	  	  if (counter > 0){
	  	 	 	  	  	  if (data3 > counter + 100){
	  	 	 	  	  		IndicationERR1();
	  	 	 	  	  		err1= 1;
	  	 	 	  	  	timer_running = false;

	  	 	 	  	  	  	  	        		  	          RELAY_PIN0;
	  	 	 	  	  	  	  	        		  	hours=0;
	  	 	 	  	  	  	  	        		  		 	minutes=0;
	  	 	 	  	  	  	  	        		  		 	seconds =0;
	  	 	 	  	  	  	  	          }else{timer_running=true;
	  	 	 	  	  	  	  	          err1 = 0;}

	  	 	 	  	  	  }



	  	 	 	  	  	  	          float error = counter - current_temperature;
	  	 	 	  	  	  	          float P = Kp * error;
	  	 	 	  	  	  	          integral += error;
	  	 	 	  	  	  	          float I = Ki *  integral;
	  	 	 	  	  	  	          float D = Kd * (error - last_error);
	  	 	 	  	  	  	          last_error = error;
	  	 	 	  	  	  	          float output = P + I + D;
	  	 	 	  	  	  	          if (output > 0) {
	  	 	 	  	  	  	     //  if (err1 = 0){
	  	 	 	  	  	  	             RELAY_PIN1;
	  	 	 	  	  	  	             err1 = 0;
	  	 	 	  	  	  	        ST7735_SetRotation(1);
	  	 	 	  	  	  	        ST7735_WriteString(5, 93, "HAGPEB", Font_11x18, RED, WHITE);
	  	 	 	  	  	  	     //  }

	  	 	 	  	  	  	          } else {
	  	 	 	  	  	  	             RELAY_PIN0;
	  	 	 	  	  	  	     //err1 = 1;
	  	 	 	  	  	  	        ST7735_SetRotation(1);
	  	 	 	  	  	  	        fillRect(5, 93, 100, 19, WHITE);


	  	 	 	  	  	  	          }



	  	 	 	  	  	  	   if (hours == 0 && minutes == 0 && seconds == 0) {
	  	 	 	  	  	  	       timer_running = false; // Остановить таймер
	  	 	 	  	  	  	fillRect(5, 93, 100, 19, WHITE);
	  	 	 	  	  	  	       Speak_Stop();
	  	 	 	  	  	  	   } else {
	  	 	 	  	  	  	if (HAL_GetTick() - last_time4 >= 900) { // Каждые 100 мс
	  	 	 	  	  	  		  	 	 	  		  		  			  	 	 	  	  	  		  	        last_time4 = HAL_GetTick();
	  	 	 	  	  	  	       if (seconds == 0 && err1 ==0) {
	  	 	 	  	  	  	           if (minutes == 0) {
	  	 	 	  	  	  	               if (hours > 0) {
	  	 	 	  	  	  	                   hours--;
	  	 	 	  	  	  	                   minutes = 59; // Сбрасываем минуты на 59
	  	 	 	  	  	  	                   seconds = 59; // Сбрасываем секунды на 59
	  	 	 	  	  	  	               }
	  	 	 	  	  	  	           } else {
	  	 	 	  	  	  	               minutes--;
	  	 	 	  	  	  	               seconds = 59; // Сбрасываем секунды на 59
	  	 	 	  	  	  	           }
	  	 	 	  	  	  	       } else {
	  	 	 	  	  	  	           seconds--; // Уменьшаем секунды
	  	 	 	  	  	  	       }
	  	 	 	  	  	  	     }
	  	 	 	  	  	  	   }
	  	 	 	  	  	  	 }else {
	  	 	 	  	  	 RELAY_PIN0;
	  	 	 	  	  	  	ST7735_SetRotation(1);

	  	 	 	  	  	  		 	  	  	  	        	  	  	  	        fillRect(5, 93, 100, 19, WHITE);
	  	 	 	  	  	  	 }

	  	 if(counter<=5 && timer_running==true){
	  	 	timer_running=false;
	  	 	hours=0;
	  	 	minutes=0;
	  	 	seconds =0;
	  	 	Speak_Stop();
	  	 }
	  	 if (hours == 0 && minutes == 10 && seconds == 0) {
	  	 	Speak_CS1;
	  	 		HAL_Delay(500);
	  	 		Speak_CS0;

	  	 }
	  	 if (hours == 0 && minutes == 5 && seconds == 0) {
	  	 	 	Speak_CS1;
	  	 	 		HAL_Delay(500);
	  	 	 		Speak_CS0;
	  	 	 		Speak_CS1;
	  	 	 		HAL_Delay(500);
	  	 	 		Speak_CS0;

	  	 	 }
	  	 if (speak_flag) {
	  	 	HAL_Delay(100);
	  	     Speak_CS1;
	  	     HAL_Delay(700); // Здесь можно использовать задержку, так как это не блокирует прерывание
	  	    Speak_CS0;
	  	     speak_flag = 0; // Сбросить флаг
	  	 }
	  	     if (speak_flag1) {
	  	         Speak_CS1;
	  	       HAL_Delay(100);
	  	        Speak_CS0;
	  	         speak_flag1 = 0;
	  	 }


	  	 	HAL_Delay(100);
    /* USER CODE BEGIN 3 */
	 // testAll();
  }
  //HAL_Delay(100);
  /* USER CODE END 3 */
}
void HAL_GPIO_EXTI_Callback(uint16_t GPIO_Pin) {
    static uint32_t last_interrupt_time = 0;
    uint32_t current_time = HAL_GetTick();
    static uint32_t last_interrupt_time1 = 0;
    uint32_t current_time1 = HAL_GetTick();

    if (GPIO_Pin == BTN__Pin) {
    	if (timer_running == 0){
        if (current_time - last_interrupt_time > 250) {

            if (counter - 5 >= 0) {
            	//Buzzer_Peak();
            	counter -= 5;
                encFlag = 1;
                speak_flag1 = 1;

            }
        	}

        }

    }


    else if (GPIO_Pin == BTN_A11_Pin) {
    	if (timer_running == 0){
        if (current_time - last_interrupt_time > 250) {

            if (counter + 5 <= 200) {
                counter += 5;
                encFlag = 1;
                speak_flag1 = 1;
               // Buzzer_Peak();
            }
        	}
        }


    }
    else if (GPIO_Pin == BTN_S_S_Pin) {
    	if (timer_running == 0){
    	if (current_time1 - last_interrupt_time1 > 250) {

    	    		if (minutes < 1440) {
    	    			speak_flag1 = 1;// Максимальное время 30 минут
    	    		        if (minutes > 29) {
    	    		            hours++;
    	    		            minutes = 0;
    	    		            seconds = 0;
    	    		        } else {
    	    		            minutes +=30;
    	    		        }
    	    		    }
    	    		if (hours==24 && minutes>0){
    	    									hours=0;
    	    			    		            minutes = 0;
    	    			    		            seconds = 0;
    	    		}
    		}
    	    	}

    	}
    else if (GPIO_Pin == BTN_T_Pin && counter>5) { // Замените на ваш пин
    	if (current_time - last_interrupt_time > 250) {
            timer_running = !timer_running; // Переключить состояние таймера
            speak_flag = 1;
        }
    }



    last_interrupt_time = current_time;
    last_interrupt_time1 = current_time1;

}
void EXTI9_5_IRQHandler(void)
{
  /* USER CODE BEGIN EXTI9_5_IRQn 0 */

  /* USER CODE END EXTI9_5_IRQn 0 */
  HAL_GPIO_EXTI_IRQHandler(BTN_T_Pin);
  /* USER CODE BEGIN EXTI9_5_IRQn 1 */

  /* USER CODE END EXTI9_5_IRQn 1 */
}

/**
  * @brief This function handles EXTI line[15:10] interrupts.
  */
void EXTI15_10_IRQHandler(void)
{
  /* USER CODE BEGIN EXTI15_10_IRQn 0 */

  /* USER CODE END EXTI15_10_IRQn 0 */
  HAL_GPIO_EXTI_IRQHandler(BTN__Pin);
  HAL_GPIO_EXTI_IRQHandler(BTN_A11_Pin);
  HAL_GPIO_EXTI_IRQHandler(BTN_S_S_Pin);
  /* USER CODE BEGIN EXTI15_10_IRQn 1 */

  /* USER CODE END EXTI15_10_IRQn 1 */
}
/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  __HAL_RCC_PWR_CLK_ENABLE();
  __HAL_PWR_VOLTAGESCALING_CONFIG(PWR_REGULATOR_VOLTAGE_SCALE2);

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_HSI;
  RCC_OscInitStruct.HSIState = RCC_HSI_ON;
  RCC_OscInitStruct.HSICalibrationValue = RCC_HSICALIBRATION_DEFAULT;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_HSI;
  RCC_OscInitStruct.PLL.PLLM = 8;
  RCC_OscInitStruct.PLL.PLLN = 84;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV2;
  RCC_OscInitStruct.PLL.PLLQ = 4;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV2;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_2) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief SPI1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_SPI1_Init(void)
{

  /* USER CODE BEGIN SPI1_Init 0 */

  /* USER CODE END SPI1_Init 0 */

  /* USER CODE BEGIN SPI1_Init 1 */

  /* USER CODE END SPI1_Init 1 */
  /* SPI1 parameter configuration*/
  hspi1.Instance = SPI1;
  hspi1.Init.Mode = SPI_MODE_MASTER;
  hspi1.Init.Direction = SPI_DIRECTION_2LINES;
  hspi1.Init.DataSize = SPI_DATASIZE_8BIT;
  hspi1.Init.CLKPolarity = SPI_POLARITY_LOW;
  hspi1.Init.CLKPhase = SPI_PHASE_1EDGE;
  hspi1.Init.NSS = SPI_NSS_SOFT;
  hspi1.Init.BaudRatePrescaler = SPI_BAUDRATEPRESCALER_8;
  hspi1.Init.FirstBit = SPI_FIRSTBIT_MSB;
  hspi1.Init.TIMode = SPI_TIMODE_DISABLE;
  hspi1.Init.CRCCalculation = SPI_CRCCALCULATION_DISABLE;
  hspi1.Init.CRCPolynomial = 10;
  if (HAL_SPI_Init(&hspi1) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN SPI1_Init 2 */

  /* USER CODE END SPI1_Init 2 */

}

/**
  * @brief SPI2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_SPI2_Init(void)
{

  /* USER CODE BEGIN SPI2_Init 0 */

  /* USER CODE END SPI2_Init 0 */

  /* USER CODE BEGIN SPI2_Init 1 */

  /* USER CODE END SPI2_Init 1 */
  /* SPI2 parameter configuration*/
  hspi2.Instance = SPI2;
  hspi2.Init.Mode = SPI_MODE_MASTER;
  hspi2.Init.Direction = SPI_DIRECTION_2LINES_RXONLY;
  hspi2.Init.DataSize = SPI_DATASIZE_8BIT;
  hspi2.Init.CLKPolarity = SPI_POLARITY_LOW;
  hspi2.Init.CLKPhase = SPI_PHASE_1EDGE;
  hspi2.Init.NSS = SPI_NSS_SOFT;
  hspi2.Init.BaudRatePrescaler = SPI_BAUDRATEPRESCALER_8;
  hspi2.Init.FirstBit = SPI_FIRSTBIT_MSB;
  hspi2.Init.TIMode = SPI_TIMODE_DISABLE;
  hspi2.Init.CRCCalculation = SPI_CRCCALCULATION_DISABLE;
  hspi2.Init.CRCPolynomial = 10;
  if (HAL_SPI_Init(&hspi2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN SPI2_Init 2 */

  /* USER CODE END SPI2_Init 2 */

}
  /* USER CODE BEGIN SPI2_Init 2 */

  /* USER CODE END SPI2_Init 2 */



/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};
  /* USER CODE BEGIN MX_GPIO_Init_1 */

  /* USER CODE END MX_GPIO_Init_1 */

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOH_CLK_ENABLE();
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOC, GPIO_PIN_15, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(SPI1_LED_GPIO_Port, SPI1_LED_Pin, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOB, SPI1_DC_Pin|SPI1_CS_Pin|SP1_RESET_Pin|SPI2_CS_Pin
                          |SPEAK_Pin|GPIO_PIN_14, GPIO_PIN_RESET);

  /*Configure GPIO pin : PC15 */
  GPIO_InitStruct.Pin = GPIO_PIN_15;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /*Configure GPIO pin : SPI1_LED_Pin */
  GPIO_InitStruct.Pin = SPI1_LED_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(SPI1_LED_GPIO_Port, &GPIO_InitStruct);

  /*Configure GPIO pins : SPI1_DC_Pin SPI1_CS_Pin SP1_RESET_Pin SPI2_CS_Pin */
  GPIO_InitStruct.Pin = SPI1_DC_Pin|SPI1_CS_Pin|SP1_RESET_Pin|SPI2_CS_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  /*Configure GPIO pins : SPEAK_Pin PB14 */
  GPIO_InitStruct.Pin = SPEAK_Pin|GPIO_PIN_14;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  /*Configure GPIO pins : BTN_T_Pin BTN__Pin BTN_A11_Pin BTN_S_S_Pin */
  GPIO_InitStruct.Pin = BTN_T_Pin|BTN__Pin|BTN_A11_Pin|BTN_S_S_Pin;
  GPIO_InitStruct.Mode = GPIO_MODE_IT_RISING;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /* EXTI interrupt init*/
  HAL_NVIC_SetPriority(EXTI9_5_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(EXTI9_5_IRQn);

  HAL_NVIC_SetPriority(EXTI15_10_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(EXTI15_10_IRQn);

  /* USER CODE BEGIN MX_GPIO_Init_2 */

  /* USER CODE END MX_GPIO_Init_2 */
}
/* USER CODE BEGIN 4 */

/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
